.........1.........2.........3.........4....^....5.........6.........7.........8

;SuperCAT by Toni Baker from ZX Computing June 1987

                          ORG  8000h
8000 C5       PAGE_(A)    PUSH BC
8001 FE05                 CP   #05
8003 2002                 JR   NZ,PAGE_(A)_2;Jump unless normal RAM required
8005 3EFF                 LD   A,#FF        ;A will contain 0 after increment
8007 3C       PAGE_(A)_2  INC  A
8008 47                   LD   B,A          ;B=page-code + 1
8009 CB38                 SRL  B            ;Divide B by two
800B 80                   ADD  A,B          ;A=absolute RAM page number
800C F610                 OR   #10          ;Include "ROM 1" bit
800E 01FD7F               LD   BC,#7FFD     ;BC=port number for paging
8011 325C5B               LD   (BANK_M),A   ;Store as current pages
8014 ED79                 OUT  (C),A        ;Page in required RAM page
8016 C1                   POP  BC
8017 C9                   RET

                          ORG  8018h
8018 50524FC7 PROG_TEXT   DEFM PROG         ;Text to be printed by program
801C 444154C1 DATA_TEXT   DEFM DATA
8020 3F3F3FBF QUES_TEXT   DEFM ????
8024 4C494EC5 LINE_TEXT   DEFM LINE
8028 0D425954 USED_TEXT
802C 45532055
8030 5345C4               DEFM BYTES USED
8033 2046494C LEFT_TEXT
8037 45534259
803B 54455320
803F 4C4546D4             DEFM FILESBYTES LEFT
8043 17170028 MAX_TEXT
8047 35363220
804B 4D4158A9             DEFM (562 MAX)

                          ORG  804Fh
804F 1A       MESSAGE     LD   A,(DE)
8050 E67F                 AND  #7F          ;A=char to print (bit 7 ignored)
8052 D7                   RST  #10          ;Print character
8053 1A                   LD   A,(DE)
8054 13                   INC  DE           ;DE points to next character
8055 17                   RLA               ;Carry = end of string bit
8056 30F7                 JR   NC,MESSAGE   ;Loop if more to come
8058 3E20                 LD   A," "
805A D7                   RST  #10          ;Print a trailing space
805B C9                   RET

                          ORG  805Ch
805C 7C       HEX_HL      LD   A,H          ;A=high part of HL
805D CD6180               CALL #8061,HEX_A  ;Print in hex
8060 7D                   LD   A,L          ;A=low part of HL
8061 F5       HEX_A       PUSH AF           ;Stack byte to print in hex
8062 1F                   RRA
8063 1F                   RRA
8064 1F                   RRA
8065 1F                   RRA               ;Low nibble = first hex digit
8066 CD6A80               CALL #806A,HEX_A_L;Print first hex digit
8069 F1                   POP  AF           ;Low nibble = last hex digit
806A E60F     HEX_A_L     AND  #0F          ;Isolate low nibble
806C F630                 OR   #30          ;Digits 0 to 9 correct
806E FE3A                 CP   #3A
8070 3802                 JR   C,HEX_A_L_2  ;Jump with digits 0 to 9
8072 C607                 ADD  A,#07        ;Digits A to F also correct
8074 D7       HEX_A_L_2   RST  #10          ;Print digit
8075 C9                   RET

                          ORG  8076h
8076 AF       DECIMAL_HL  XOR  A            ;A=00
8077 E5       DECIMAL_AHL PUSH HL
8078 D5                   PUSH DE           ;Stack registers
8079 C5                   PUSH BC
807A F5                   PUSH AF           ;Stack high byte of AHL
807B 44                   LD   B,H
807C 4D                   LD   C,L          ;BC=low word of AHL
807D CD2B2D               CALL STACK_BC     ;Push onto calculator stack
8080 F1                   POP  AF           ;A=high byte of AHL
8081 CD282D               CALL STACK_A      ;Push onto calculator stack
8084 EF                   RST  #28          ;Switch on calculator
                                            ;Lo,Hi
8085 34004140             stk data 65536
                          (91 00 00 00 00)  ;Lo,Hi,65536
8089 04                   multiply          ;Lo,65536*Hi
808A 0F                   add               ;X
808B 2E                   str$              ;STR$ X
808C 38                   end calc          ;Switch off calculator
808D CDF12B               CALL STK_FETCH    ;BC=length of string
                                            ;DE=address of string
8090 F1                   POP  AF           ;A=required number of characters
8091 F5                   PUSH AF
8092 91                   SUB  C            ;A=required number of leading spaces
8093 3809                 JR   C,DECIMAL_P  ;Jump if string too long
8095 2807                 JR   Z,DECIMAL_P  ;Jump if string exactly right length
8097 6F                   LD   L,A          ;L=required number of leading spaces
8098 3E20     DEC_LOOP    LD   A," "
809A D7                   RST  #10          ;Print leading space
809B 2D                   DEC  L
809C 20FA                 JR   NZ,DEC_LOOP  ;Loop to print remaining spaces
809E CD3C20   DECIMAL_P   CALL PR_STRING    ;Print number in decimal
80A1 C1                   POP  BC
80A2 D1                   POP  DE           ;Restore registers
80A3 E1                   POP  HL
80A4 C9                   RET

                          ORG  80A5h
80A5 060A     PRINT_FILE  LD   B,#0A        ;B=length of file name
80A7 7E       PF_LOOP     LD   A,(HL)       ;A=next character from file name
80A8 23                   INC  HL
80A9 D7                   RST  #10          ;Print character
80AA 10FB                 DJNZ PF_LOOP      ;Print whole of file name
80AC 3E20                 LD   A," "
80AE D7                   RST  #10          ;Follow it by a space
80AF 5E                   LD   E,(HL)
80B0 23                   INC  HL
80B1 56                   LD   D,(HL)       ;DE=address of file
80B2 23                   INC  HL
80B3 7E                   LD   A,(HL)       ;A=page-code of start of file
80B4 23                   INC  HL
80B5 4E                   LD   C,(HL)
80B6 23                   INC  HL
80B7 46                   LD   B,(HL)       ;BC=low word of length of file
80B8 23                   INC  HL
80B9 C5                   PUSH BC
80BA 4E                   LD   C,(HL)       ;C=high byte of length of file
80BB E1                   POP  HL           ;CHL=length of file
80BC EB                   EX   DE,HL        ;CDE=length of file
                                            ;AHL=page-coded address of file
80BD F5                   PUSH AF
80BE E5                   PUSH HL           ;Stack page-coded address of file
80BF 2A7A5B               LD   HL,(SC_00)
80C2 3A7C5B               LD   A,(SC_00+2)  ;AHL=number of bytes used so far
80C5 19                   ADD  HL,DE
80C6 89                   ADC  A,C          ;AHL=new sub-total
80C7 D5                   PUSH DE
80C8 111400               LD   DE,#0014
80CB 19                   ADD  HL,DE
80CC 8A                   ADC  A,D          ;Include 20d bytes for cat entry
80CD D1                   POP  DE
80CE 227A5B               LD   (SC_00),HL
80D1 327C5B               LD   (SC_00+2),A  ;Store new sub-total
80D4 E1                   POP  HL
80D5 F1                   POP  AF           ;AHL=page-coded address of file
80D6 C5                   PUSH BC
80D7 D5                   PUSH DE           ;Stack length of file
80D8 010900               LD   BC,#0009     ;BC=length of header info
80DB 11715B               LD   DE,HD_00     ;DE points to header buffer
80DE F5       PF_HD_PAGE  PUSH AF
80DF CD0080               CALL PAGE_(A)     ;Page in next byte of header info
80E2 F1                   POP  AF
80E3 EDA0     PF_HD_BYTE  LDI               ;Transfer one byte into buffer
80E5 E2F280               JP   PO,PF_TYPE   ;Jump if all 9 bytes transferred
80E8 CB7C                 BIT  7,H
80EA 20F7                 JR   NZ,PF_HD_BYTE;Jump if next byte on same page
80EC 2100C0               LD   HL,#C000     ;HL points to start of (next) page
80EF 3C                   INC  A            ;Increment coded page number
80F0 18EC                 JR   PF_HD_PAGE   ;Jump back for remaining bytes

                          ORG  80F2h
80F2 E1       PF_TYPE     POP  HL
80F3 C1                   POP  BC           ;CHL=length of file
80F4 3A715B               LD   A,(HD_00)    ;A=file type
80F7 111880               LD   DE,PROG_TEXT
80FA A7                   AND  A
80FB 280D                 JR   Z,PF_MESSAGE ;Jump if file is PROGRAM
80FD 1E1C                 LD   E,DATA_TEXT lo
80FF 3D                   DEC  A
8100 2808                 JR   Z,PF_MESSAGE ;Jump if numeric array
8102 3D                   DEC  A
8103 2805                 JR   Z,PF_MESSAGE ;Jump if string array
8105 3D                   DEC  A
8106 2835                 JR   Z,PF_CODE    ;Jump if CODE
8108 1E20                 LD   E,QUES_TEXT lo
810A CD4F80   PF_MESSAGE  CALL #804F,MESSAGE;Print file type
810D 3A715B               LD   A,(HD_00)    ;A=file type
8110 FE04                 CP   #04
8112 380F                 JR   C,PF_STANDARD;Jump unless file is non-standard
8114 3E17                 LD   A,#17
8116 D7                   RST  #10
8117 3E1A                 LD   A,#1A
8119 D7                   RST  #10
811A D7                   RST  #10          ;Print TAB 26;
811B 79                   LD   A,C          ;AHL=length of file
811C 0606                 LD   B,#06        ;Signal "six digits required"
811E CD7780               CALL DECIMAL_AHL  ;Print length of file
8121 185D                 JR   PF_EXIT      ;Jump to exit

8123 A7       PF_STANDARD AND  A
8124 2038                 JR   NZ,PF_DATA   ;Jump unless file is PROGRAM
8126 21795B               LD   HL,HD_11+1
8129 CB7E                 BIT  7,(HL)
812B 2046                 JR   NZ,PFLENEXIT ;Jump unless auto-run line number
                                            ;exists
812D 112480               LD   DE,LINE_TEXT
8130 CD4F80               CALL #804F,MESSAGE;PRINT "LINE ";
8133 2A785B               LD   HL,(HD_11)   ;HL=auto-run line number
8136 0600                 LD   B,#00        ;Signal "indefinite number of digits"
8138 CD7680               CALL DECIMAL_HL   ;Print auto-run line number
813B 1836                 JR   PFLENEXIT    ;Jump to exit

813D 2A745B   PF_CODE     LD   HL,(HD_0D)   ;HL=address of CODE block
8140 E5                   PUSH HL
8141 CD5C80               CALL #805C,HEX_HL ;Print in hex
8144 3E2D                 LD   A,"-"
8146 D7                   RST  #10          ;Print "-";
8147 ED5B725B             LD   DE,(HD_0B)   ;HL=length of CODE block
814B 19                   ADD  HL,DE
814C 2B                   DEC  HL           ;HL=address of last byte of block
814D CD5C80               CALL #805C,HEX_HL ;Print in hex
8150 3E20                 LD   A," "
8152 D7                   RST  #10          ;Print a space
8153 E1                   POP  HL           ;HL=address of CODE block
8154 0605                 LD   B,#05        ;Signal "five digits"
8156 CD7680               CALL DECIMAL_HL   ;Print in decimal
8159 3E2C                 LD   A,","
815B D7                   RST  #10          ;Print separating comma
815C 181A                 JR   PFCODEEXIT   ;Jump to exit

815E 47       PF_DATA     LD   B,A          ;B=file type
815F 3A765B               LD   A,(HD_0F)    ;A=variable name
8162 E63F                 AND  #3F
8164 F640                 OR   #40          ;Convert to ASCII character
8166 D7                   RST  #10          ;Print it
8167 05                   DEC  B
8168 2803                 JR   Z,PF_DATA_2  ;Jump if numeric array
816A 3E24                 LD   A,"$"
816C D7                   RST  #10          ;Print "$";
816D 3E28     PF_DATA_2   LD   A,"("
816F D7                   RST  #10          ;Print "(";
8170 3E29                 LD   A,")"
8172 D7                   RST  #10          ;Print ")";
8173 3E1B     PFLENEXIT   LD   A,#1B
8175 CDC30A               CALL #0AC3,TAB_A  ;PRINT TAB 27;
8178 2A725B   PFCODEEXIT  LD   HL,(HD_0B)   ;HL=length of BASIC file
817B 0605                 LD   B,#05        ;Signal "five digits"
817D CD7680               CALL DECIMAL_HL   ;Print in decimal
8180 3E0D     PF_EXIT     LD   A,#0D
8182 D7                   RST  #10          ;Print a newline
8183 3E04                 LD   A,#04
8185 C30080               JP   PAGE_(A)     ;Page in catalogue and return

                          ORG  8188h
8188 00000000 MINIMUM     DEFB 00,00,00,00
818C 00000000             DEFB 00,00,00,00
8190 0000                 DEFB 00,00

                          ORG  8192h
8192 FFFFFFFF MAXIMUM     DEFB FF,FF,FF,FF
8196 FFFFFFFF             DEFB FF,FF,FF,FF
819A FFFF                 DEFB FF,FF

                          ORG  819Ch
819C C5       CP_NAME     PUSH BC
819D D5                   PUSH DE
819E E5                   PUSH HL
819F EB                   EX   DE,HL        ;DE points to name used for
                                            ;comparison
81A0 60                   LD   H,B
81A1 69                   LD   L,C          ;HL points to file name under test
81A2 060A                 LD   B,#0A        ;B=length of file name
81A4 1A       CP_NM_LOOP  LD   A,(DE)
81A5 13                   INC  DE
81A6 BE                   CP   (HL)         ;Compare next character
81A7 23                   INC  HL
81A8 2002                 JR   NZ,CP_NM_EXIT;Jump if character is different
81AA 10F8                 DJNZ CP_NM_LOOP   ;Repeat comparison for all chars
81AC E1       CP_NM_EXIT  POP  HL
81AD D1                   POP  DE
81AE C1                   POP  BC
81AF C9                   RET

                          ORG  81B0h
81B0 3E02     SUPERCAT    LD   A,#02
81B2 CD0116               CALL CHAN_OPEN    ;Select stream 2 (upper screen)
81B5 217A5B               LD   HL,SC_00
81B8 0603                 LD   B,#03
81BA 3600     SC_RESET    LD   (HL),#00
81BC 23                   INC  HL
81BD 10FB                 DJNZ SC_RESET     ;Reset "number of bytes used" and
                                            ;"number of files" counters
81BF 3E04                 LD   A,#04
81C1 CD0080               CALL PAGE_(A)     ;Page in RAM page containing cat
81C4 218881               LD   HL,MINIMUM
81C7 119281   SC_OUTER    LD   DE,MAXIMUM
81CA 01ECEB               LD   BC,#EBEC     ;BC points to first catalogue entry
81CD E5       SC_INNER    PUSH HL
81CE 2A835B               LD   HL,(SF_NEXT) ;HL points to "end of cat" marker
81D1 A7                   AND  A
81D2 ED42                 SBC  HL,BC
81D4 E1                   POP  HL
81D5 2818                 JR   Z,SC_FOUND   ;Jump if whole of catalogue has 
                                            ;been searched
81D7 CD9C81               CALL #819C,CP_NAME
81DA 3009                 JR   NC,SC_NEXT   ;Jump if name precedes or equals
                                            ;minimum, alphabetically
81DC EB                   EX   DE,HL
81DD CD9C81               CALL #819C,CP_NAME
81E0 EB                   EX   DE,HL
81E1 3802                 JR   C,SC_NEXT    ;Jump if name follows maximum,
                                            ;alphabetically
81E3 50                   LD   D,B
81E4 59                   LD   E,C          ;Set new upper limit
81E5 E5       SC_NEXT     PUSH HL
81E6 21ECFF               LD   HL,#FFEC
81E9 09                   ADD  HL,BC
81EA 44                   LD   B,H
81EB 4D                   LD   C,L          ;BC points to next cat entry
81EC E1                   POP  HL
81ED 18DE                 JR   SC_INNER     ;Repeat for all cat entries

81EF E5       SC_FOUND    PUSH HL
81F0 219281               LD   HL,MAXIMUM
81F3 A7                   AND  A
81F4 ED52                 SBC  HL,DE
81F6 E1                   POP  HL
81F7 2808                 JR   Z,SC_DONE    ;Jump if all files dealt with
81F9 EB                   EX   DE,HL        ;HL points to catalogue entry
81FA E5                   PUSH HL
81FB CDA580               CALL PRINT_FILE   ;Print info for this file
81FE E1                   POP  HL
81FF 18C6                 JR   SC_OUTER     ;Repeat for all cat entries

8201 112880   SC_DONE     LD   DE,USED_TEXT
8204 CD4F80               CALL #804F,MESSAGE;PRINT "BYTES USED ";
8207 2A7A5B               LD   HL,(SC_00)
820A 3A7C5B               LD   A,(SC_00+2)  ;AHL=number of bytes used
820D 0606                 LD   B,#06        ;Signal "six digits"
820F CD7780               CALL DECIMAL_AHL  ;Print number of bytes used
8212 3E17                 LD   A,#17
8214 CDC30A               CALL #0AC3,TAB_A  ;PRINT TAB 23;
8217 21ECEB               LD   HL,#EBEC
821A ED5B835B             LD   DE,(SF_NEXT)
821E A7                   AND  A
821F ED52                 SBC  HL,DE        ;HL=length of cat stack - 14h
8221 01ECFF               LD   BC,#FFEC     ;BC=-14h
8224 11FFFF               LD   DE,#FFFF     ;DE=-1
8227 13       SC_FILES    INC  DE           ;DE counts files
8228 09                   ADD  HL,BC
8229 38FC                 JR   C,SC_FILES   ;Count all files
822B EB                   EX   DE,HL        ;HL=number of files
822C 0603                 LD   B,#03        ;Signal "three digits"
822E CD7680               CALL DECIMAL_HL   ;Print number of files
8231 113380               LD   DE,LEFT_TEXT
8234 CD4F80               CALL #804F,MESSAGE;PRINT "FILESBYTES LEFT ";
8237 2A855B               LD   HL,(SF_SPACE);AHL=number of bytes unused
823A 3A875B               LD   A,(SF_SPACE+2)
823D 0606                 LD   B,#06        ;Signal "six digits"
823F CD7780               CALL DECIMAL_AHL  ;Print number of bytes remaining
8242 114380               LD   DE,MAX_TEXT
8245 CD4F80               CALL #804F,MESSAGE;PRINT TAB 23;"(562 MAX)"
8248 3E0D                 LD   A,#0D
824A D7                   RST  #10          ;Print extra newline at end
824B 3E05                 LD   A,#05
824D C30080               JP   PAGE_(A)     ;Page in normal RAM and return
